#!/bin/sh

# rescue-backup.sh (W) 2010 by peter@holik.at

cat >root_exclude <<EOF
/home/user/backup/*.bz2
/lost+found/*
/var/log/mail.*
/var/log/daemon*
/var/log/kern*
/var/log/syslog*
/var/log/messages*
/var/log/cron*
/var/log/apache2/*
/tmp/*
EOF

sudo tar -cjSp --one-file-system --numeric-owner --atime-preserve --exclude-from=root_exclude -f $(hostname).root.tar.bz2 /

uuid() { sudo blkid -o value -s UUID /dev/$1; }
raiduuid() { sudo sed -n "s/^.*$1.*UUID=\(.*\)/\1/p" /etc/mdadm/mdadm.conf; }
fstype() { sudo blkid -o value -s TYPE /dev/$1; }
inodesize() { sudo tune2fs -l /dev/$1 | grep "Inode size" | sed -e 's/[^0-9]//g'; }
partitioninfo() { echo "$(echo $1|sed -e 's/[^0-9]//g') $(uuid $1) $(fstype $1)"; }

cat >$(hostname).cfg <<EOF
DISK_PARTITIONS=",8000,S;,,L,* ,8000,S;,,L,*"
RAID_UUIDS="$(raiduuid md0) $(raiduuid md1)"
ARCHIVES="$(partitioninfo md1) $(hostname).root.tar.bz2"
SWAP="0 $(uuid md0)"
GRUB=1
GRUB1_PARTITION=1
GRUB1_INODESIZE=$(inodesize md1)
EOF
