#!/bin/sh

# rescue-backup.sh (W) 2010 by peter@holik.at

cat >root_exclude <<EOF
/home/user/backup/*.bz2
/lost+found/*
/tmp/*
EOF

cat >var_exclude <<EOF
./tmp/*
./run/*
./lock/*
./log/mail*
./log/messages*
./log/lastlog
./log/auth*
./log/user*
./log/syslog*
./log/kern*
./log/debug*
./log/daemon*
./log/dmesg*
./log/dpkg*
./log/faillog*
./log/wtmp*
./log/btmp*
./log/lpr*
./log/boot*
./log/udev*
./log/uucp*
./log/fsck/*
./lost+found/*
EOF

sudo tar -cSp --one-file-system --numeric-owner --atime-preserve --exclude-from=root_exclude -f $(hostname).root.tar /

sudo tar -cjSp --one-file-system --numeric-owner --atime-preserve --exclude-from=var_exclude -f $(hostname).var.tar.bz2 --directory /var .

uuid() { sudo blkid -o value -s UUID /dev/$1; }
fstype() { sudo blkid -o value -s TYPE /dev/$1; }
inodesize() { sudo tune2fs -l /dev/$1 | grep "Inode size" | sed -e 's/[^0-9]//g'; }
partitioninfo() { echo "$(echo $1|sed -e 's/[^0-9]//g') $(uuid $1) $(fstype $1)"; }

cat >$(hostname).cfg <<EOF
DISK_PARTITIONS=",1024,S;,10000,L,*;,,L"
ARCHIVES="$(partitioninfo sda2) $(hostname).root.tar.bz2
$(partitioninfo sda3) $(hostname).var.tar.bz2"
SWAP="1 $(uuid sda1)"
GRUB=1
GRUB1_PARTITION=1
GRUB1_INODESIZE=$(inodesize sda2)
EOF
