#!/bin/sh

# rescue-create-stick.sh (W) 2010 by peter@holik.at

[ $# -eq 1 ] || { echo "Usually: $0 /dev/stick_device"; exit; }

[ "$(cat /sys/block/${1##*/}/removable)" = "1" ] || { echo "Your stick is not a removeable device?"; exit; }

[ $(id -u) -eq 0 ] || { echo "run sudo $0"; exit; }

IMAGEDIR=image

sfdisk -q -uM -L ${1} <<SFDISK
,,L,*
SFDISK
cat /usr/lib/syslinux/mbr.bin > ${1}
mkfs.ext2 ${1}1
tune2fs -i 0 ${1}1
mkdir -p mnt
mount ${1}1 mnt
extlinux --install mnt
cat >mnt/extlinux.conf <<EOF
timeout 1
default vmlinuz
append initrd=initrd.img quiet
EOF
cp ${IMAGEDIR}/* ${IMAGEDIR}/.initramfs-backup mnt
umount mnt
